// code by jph
package mid;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.stream.Stream;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiSystem;

public abstract class Midi {
  /** function drops related MIDI devices entries for a faster retrieval
   * 
   * @return */
  public final List<MidiDevice.Info> getMidiDeviceInfoCompact() {
    final int maxMidi = 5; // TODO magic const
    List<MidiDevice.Info> myList = new LinkedList<>();
    Map<String, Integer> myMap = new HashMap<>();
    for (MidiDevice.Info myMidiDeviceInfo : MidiSystem.getMidiDeviceInfo()) {
      String myString = myMidiDeviceInfo.toString();
      int index = myString.indexOf('[');
      if (0 < index)
        myString = myString.substring(0, index);
      if (!myMap.containsKey(myString) || myMap.get(myString) < maxMidi)
        try {
          // System.out.print("try " + myMidiDeviceInfo);
          boolean accept = acceptMidiDevice(myMidiDeviceInfo);
          if (accept) {
            if (!myMap.containsKey(myString))
              myMap.put(myString, 1);
            myMap.put(myString, myMap.get(myString) + 1);
            myList.add(myMidiDeviceInfo);
          }
        } catch (Exception myException) {
          myException.printStackTrace();
        }
    }
    return myList;
  }

  public final Stream<MidiDevice.Info> getMidiDeviceInfo() {
    return Stream.of(MidiSystem.getMidiDeviceInfo()) //
        .filter(myMidiDeviceInfo -> {
          try {
            return acceptMidiDevice(myMidiDeviceInfo);
          } catch (Exception myException) {
            myException.printStackTrace();
          }
          return false;
        });
  }

  /** @param myMidiDeviceInfo
   * @return if myMidiDeviceInfo is suitable for midi-in or midi-out
   * @throws Exception */
  protected abstract boolean acceptMidiDevice(MidiDevice.Info myMidiDeviceInfo) throws Exception;
}
