// code by jph
package mid;

import javax.sound.midi.MidiDevice;
import javax.sound.midi.MidiDevice.Info;
import javax.sound.midi.MidiSystem;
import javax.sound.midi.MidiUnavailableException;

public class MidiDeviceInfoAutoCloseable implements AutoCloseable {
  private Info myInfo = null;

  public final void switchInfo(Info myInfo) {
    try {
      close();
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    this.myInfo = myInfo;
  }

  public Info getMidiDeviceInfo() {
    return myInfo;
  }

  public MidiDevice getMidiDevice() throws MidiUnavailableException {
    return MidiSystem.getMidiDevice(myInfo);
  }

  public boolean isAvailable() {
    return myInfo != null;
  }

  @Override
  public void close() throws Exception {
    if (myInfo != null) {
      getMidiDevice().close();
      myInfo = null;
    }
  }
}
