// code by jph
package mid;

import java.util.function.Predicate;

import javax.sound.midi.MidiDevice.Info;

import sys.Manager;
import tpf.dat.loc.Local;

public class MidiIO {
  private static MidiIO instance = null;

  public static MidiIO getInstance() {
    if (instance == null)
      instance = new MidiIO();
    return instance;
  }

  // ---
  private Manager myManager = Local.getInstance().getUserManager(getClass()); // bad design
  public MidiDeviceInfoAutoCloseable myMidiDeviceInfoAutoCloseable_O = new MidiDeviceInfoAutoCloseable();
  public MidiDeviceInfoAutoCloseable myMidiDeviceInfoAutoCloseable_I = new MidiDeviceInfoAutoCloseable();

  private MidiIO() {
    configure();
  }

  static Predicate<Info> createPredicate(String myString) {
    return myInfo -> myInfo.toString().trim().equalsIgnoreCase(myString);
  }

  private void configure() {
    {
      String myString = myManager.getString("MidiOut", "");
      System.out.println("MidiOut=" + myString);
      MidiOut.instance.getMidiDeviceInfoCompact().stream() //
          .filter(createPredicate(myString)) //
          .findFirst() //
          .ifPresent(myMidiDeviceInfoAutoCloseable_O::switchInfo);
    }
    // ---
    {
      // TODO midiIn not yet available
      // MidiIn.instance.getMidiDeviceInfoCompact().stream() //
      // .filter(createPredicate(myManager.getString("MidiIn", ""))) //
      // .findFirst() //
      // .ifPresent(myMidiDeviceInfoAutoCloseable_I::switchMidiDeviceInfo);
    }
  }

  public void setMidiOut(Info myInfo) {
    myMidiDeviceInfoAutoCloseable_O.switchInfo(myInfo);
    myManager.setProperty("MidiOut", myInfo == null ? "" : myInfo.toString());
    myManager.manifest();
  }

  public void setMidiIn(Info myInfo) {
    myMidiDeviceInfoAutoCloseable_I.switchInfo(myInfo);
    myManager.setProperty("MidiIn", myInfo == null ? "" : myInfo.toString());
    myManager.manifest();
  }
}
