// code by jph
package sys;

import java.io.File;

public class FileDelete {
  final int max_depth;
  private int count = 0;
  private int deleted = 0;

  public FileDelete(File myFile, int max_depth, int max_count) {
    this.max_depth = max_depth;
    // ---
    visitRecursively(myFile, 0, false);
    if (count <= max_count) {
      visitRecursively(myFile, 0, true);
    } else
      throw new RuntimeException("more files to be deleted than allowed (" + max_count + "<=" + count + ") in " + myFile);
  }

  private void visitRecursively(File myFile, int depth, final boolean delete) {
    if (myFile.isDirectory() && depth <= max_depth) // isDirectory returns false, if directory does not exist
      for (File myEntry : myFile.listFiles())
        visitRecursively(myEntry, depth + 1, delete);
    ++count;
    if (delete) {
      // System.out.println("delete "+myFile);
      boolean myBoolean = myFile.delete();
      deleted += myBoolean ? 1 : 0;
    }
  }

  public int deletedCount() {
    return deleted;
  }
}
