// code by jph
package sys.col;

import java.awt.Color;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

import sys.mat.IntegerMath;

public abstract class Palette implements Iterable<Color> {
  public abstract int size();

  public abstract Color getColor(int index, double saturation, double value, double alpha);

  public final Color getColorCyclic(int index, double saturation, double value, double alpha) {
    return getColor(IntegerMath.mod(index, size()), saturation, value, alpha);
  }

  public final Color getColor(int index) {
    return getColor(index, 1, 1, 1);
  }

  public final Color getColorCyclic(int index) {
    return getColor(IntegerMath.mod(index, size()));
  }

  @Override
  public final Iterator<Color> iterator() {
    List<Color> myList = new LinkedList<>();
    for (int index = 0; index < size(); ++index)
      myList.add(getColor(index));
    return myList.iterator();
  }

  // @Deprecated
  // public ImageIcon getImageIcon() {
  // BufferedImage myBufferedImage = new BufferedImage(16, 16, BufferedImage.TYPE_INT_RGB);
  // Graphics myGraphics = myBufferedImage.getGraphics();
  // int piy = 0;
  // for (Color myColor : this) {
  // myGraphics.setColor(myColor);
  // myGraphics.fillRect(0, piy, 16, 2);
  // piy += 2;
  // }
  // return new ImageIcon(myBufferedImage);
  // }
  public void printTable() {
    for (Color myColor : this) {
//      System.out.println(String.format("! %3d %3d %3d", myColor.getRed(), myColor.getGreen(), myColor.getBlue()));
      System.out.println(String.format("{ %3d/255.0, %3d/255.0, %3d/255.0, %3d/255.0}, //", myColor.getRed(), myColor.getGreen(), myColor.getBlue(), myColor.getAlpha()));
      Hue myHue = Hue.fromColor(myColor);
//      System.out.println(myHue.toFriendlyString());
    }
  }
}
