// code by jph
package sys.col;

import java.awt.Color;
import java.awt.Container;
import java.awt.GridLayout;
import java.awt.Window;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JSlider;
import javax.swing.WindowConstants;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

class PalettePreview implements ChangeListener {
  final Palette myPalette;
  List<JLabel> myJLabels = new ArrayList<>();
  JSlider myJSliderS = new JSlider(0, 255, 255); // 142 saturate
  JSlider myJSliderV = new JSlider(0, 255, 255); // bright

  public PalettePreview(Window myWindow, Palette myPalette) {
    this.myPalette = myPalette;
    JFrame myJDialog = new JFrame(); // new JDialog(myWindow, Dialog.ModalityType.APPLICATION_MODAL);
    // myJDialog.setIconImage(myImageIcon.getImage());
    myJDialog.setResizable(false);
    myJDialog.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    myJDialog.setTitle(getClass().getSimpleName());
    // ---
    Container myContainer = myJDialog.getContentPane();
    final int rows = myPalette.size() + 2;
    myContainer.setLayout(new GridLayout(rows, 1));
    {
      myJSliderS.addChangeListener(this);
      myJSliderS.setToolTipText("saturation");
      myContainer.add(myJSliderS);
    }
    {
      myJSliderV.addChangeListener(this);
      myJSliderV.setToolTipText("value");
      myContainer.add(myJSliderV);
    }
    for (int count = 0; count < myPalette.size(); ++count) {
      JLabel myJLabel = new JLabel();
      myJLabel.setOpaque(true);
      myContainer.add(myJLabel);
      myJLabels.add(myJLabel);
    }
    myJDialog.setBounds( //
        200, 100, //
        280, rows * 28 + 40);
    stateChanged(null);
    myJDialog.setVisible(true);
  }

  @Override
  public void stateChanged(ChangeEvent myChangeEvent) {
    for (int count = 0; count < myPalette.size(); ++count) {
      Color myColor = myPalette.getColor(count, myJSliderS.getValue() / 255., myJSliderV.getValue() / 255., 1);
      Hue myHue = Hue.fromColor(myColor);
      myJLabels.get(count).setText(myHue.toFriendlyString() + " " + Math.round(myHue.h * 360));
      myJLabels.get(count).setBackground(myColor);
    }
  }

  public static void main(String[] args) {
    // new PalettePreview(null, CustomPalette.default_palette);
    new PalettePreview(null, HuePalette.default13);
    new PalettePreview(null, new LumaPalette(HuePalette.default13,LumaPalette.brighten_weights));
    // new PalettePreview(null, HuePalette.prime(12, new Fraction(2, 5)));
  }
}
