// code by jph
package sys.dat;

public class DurationChop {
  public static DurationChop fromMillis(long millis) {
    return new DurationChop(millis * 1000000);
  }

  public static DurationChop fromNanos(long nanos) {
    return new DurationChop(nanos);
  }

  public final long nanos;
  public final int nan;
  public final int mic;
  public final int mil;
  public final int sec;
  public final int min;
  public final int hrs;

  private DurationChop(long delta) {
    this.nanos = delta;
    nan = (int) (delta % 1000L);
    delta /= 1000;
    mic = (int) (delta % 1000L);
    delta /= 1000;
    mil = (int) (delta % 1000);
    delta /= 1000;
    // ---
    sec = (int) (delta % 60);
    delta /= 60;
    // ---
    min = (int) (delta % 60);
    delta /= 60;
    // ---
    hrs = (int) (delta);
  }

  public String toHMS() {
    return String.format("%02d:%02d:%02d", hrs, min, sec);
  }

  public String toHMSM() {
    return String.format("%02d:%02d:%02d.%03d", hrs, min, sec, mil);
  }

  public String toSMM() {
    return String.format("%02d.%03d_%03d", sec, mil, mic);
  }

  public String toSM() {
    return String.format("%02d.%03d", sec, mil);
  }
}
