// code by jph
package sys.dat;

/** tracks/estimates duration of user interaction using a single function invocation */
public class DurationTracker {
  private final long maxInterval;
  private boolean myBoolean = false;
  public long millis = 0;
  private long tic;

  /** @param maxInterval for capping */
  public DurationTracker(long maxInterval) {
    this.maxInterval = maxInterval;
  }

  public void markNow() {
    long toc = System.nanoTime();
    if (myBoolean) {
      long delta = (toc - tic) / 1000000;
      millis += Math.min(delta, maxInterval);
    }
    myBoolean = true;
    tic = toc;
  }
}
