// code by jph
package sys.dat;

import java.io.Writer;
import java.util.Stack;

public abstract class XmlWriter {
  /** preallocated buffer of spaces */
  private static final String spacing = //
  "                                                                                       ";

  public static String convertChars(String myString) {
    myString = myString.replaceAll("<", "&lt;");
    myString = myString.replaceAll(">", "&gt;");
    return myString;
  }

  private final Writer myWriter;
  private final Stack<String> myStack = new Stack<>();

  public XmlWriter(Writer myWriter) {
    this.myWriter = myWriter;
  }

  protected void push(String myString) throws Exception {
    writeln("<" + myString + ">");
    myStack.push(myString);
  }

  protected void push(String myString, String myParams) throws Exception {
    writeln("<" + myString + " " + myParams + ">");
    myStack.push(myString);
  }

  protected void pop(String myString) throws Exception {
    String myVerify = myStack.peek(); // the object at the top of this stack without removing it from the stack
    if (!myVerify.equals(myString))
      throw new RuntimeException(myString + ", but expected: " + myVerify);
    pop();
  }

  protected void pop() throws Exception {
    String myString = myStack.pop();
    writeln("</" + myString + ">");
  }

  protected void content(String myString) throws Exception {
    writeln(convertChars(myString));
  }

  protected void writeln(String myString) throws Exception {
    myWriter.write(spacing.substring(0, myStack.size()) + myString);
    myWriter.write('\n');
  }

  protected boolean isStackEmpty() {
    return myStack.isEmpty();
  }

  protected void checkStackEmpty() {
    if (!isStackEmpty())
      new RuntimeException("stack not empty").printStackTrace();
  }

  protected void flush() throws Exception {
    myWriter.flush();
  }

  protected void close() throws Exception {
    myWriter.close();
    // ---
    checkStackEmpty();
  }
}
