// code by jph
package sys.dat;

import java.io.File;
import java.io.FileOutputStream;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import sys.BinaryFile;

public class ZipCompress {
  private final ZipOutputStream myZipOutputStream;

  public ZipCompress(File src, File dst) throws Exception {
    myZipOutputStream = new ZipOutputStream(new FileOutputStream(dst));
    visit(src, src.getName());
    myZipOutputStream.close();
  }

  private void visit(File dir, final String prefix) throws Exception {
    for (File myFile : dir.listFiles()) {
      final String name = prefix + '/' + myFile.getName(); // zip entries require / as file separator
      if (myFile.isDirectory())
        visit(myFile, name);
      else {
        // System.out.println(name);
        myZipOutputStream.putNextEntry(new ZipEntry(name));
        myZipOutputStream.write(BinaryFile.read(myFile));
        myZipOutputStream.closeEntry();
      }
    }
  }
}
