// code by jph
package sys.gui;

import java.awt.Color;
import java.awt.Font;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.io.File;
import java.io.FileFilter;

import javax.swing.JTextField;

public class FileField {
  public static final Color color_fine = new Color(192, 255, 192);
  public static final Color color_nok = new Color(255, 192, 192);
  // ---
  public String myTitle = "";
  public final JTextField myJTextField = new JTextField();
  final FileFilter myFileFilter;

  public FileField(FileFilter myFileFilter) {
    myJTextField.setFont(new Font(Font.MONOSPACED, Font.PLAIN, 12));
    this.myFileFilter = myFileFilter;
    myJTextField.addKeyListener(new KeyAdapter() {
      @Override
      public void keyTyped(KeyEvent myKeyEvent) {
        updateGui();
      }

      @Override
      public void keyReleased(KeyEvent myKeyEvent) {
        updateGui();
      }
    });
  }

  public void setTitle(String myTitle) {
    this.myTitle = myTitle;
  }

  public void setFile(File myFile) {
    myJTextField.setText(myFile.toString());
    updateGui();
  }

  public void setText(String myString) {
    try {
      myJTextField.setText(myString);
      File myFile = new File(myString);
      setFile(myFile);
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    updateGui();
  }

  public boolean isValid() {
    try {
      String myString = myJTextField.getText();
      File myFile = new File(myString);
      return myFileFilter == null || myFileFilter.accept(myFile);
    } catch (Exception myException) {
      myException.printStackTrace();
    }
    return false;
  }

  public void updateGui() {
    myJTextField.setBackground(isValid() ? color_fine : color_nok);
  }

  public String getManagerString() {
    return myJTextField.getText().replace('\\', '/');
  }
}
