// code by jph
package sys.gui;

import java.awt.Color;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;

import sys.col.LumaPalette;

public abstract class SpinnerButton {
  public final JButton myJButton = new JButton();
  private int value = 0;
  public final int max;

  public SpinnerButton(final int max) {
    this.max = max;
    myJButton.addActionListener(new ActionListener() {
      @Override
      public void actionPerformed(ActionEvent myActionEvent) {
        ++value;
        value %= max;
        myJButton.setBackground(getBackgroundColor());
        action(value);
      }
    });
    myJButton.setBackground(getBackgroundColor());
  }

  public Color getBackgroundColor() {
    return 0 == value ? null : LumaPalette.default13.getColor(value - 1);
  }

  public void setValue(int value) {
    this.value = value;
    myJButton.setBackground(getBackgroundColor());
  }

  public abstract void action(int value);
}
