// code by jph
package sys.lic;

import java.nio.ByteBuffer;
import java.nio.charset.Charset;
import java.security.MessageDigest;
import java.util.zip.Deflater;
import java.util.zip.Inflater;

public class CryptBytes {
  final MessageDigest myMessageDigest = MessageDigest.getInstance("SHA-256");
  double[] myDouble;

  public static String hexString(byte[] message, int offset, int length, String pattern) {
    StringBuilder myStringBuffer = new StringBuilder();
    for (int c1 = 0; c1 < length; ++c1)
      myStringBuffer.append(String.format(pattern, message[offset + c1]));
    return myStringBuffer.toString();
  }

  CryptBytes(String key) throws Exception {
    ByteBuffer myByteBuffer = ByteBuffer.wrap(myMessageDigest.digest(key.getBytes(Charset.forName("UTF-8"))));
    int num = myByteBuffer.array().length / 8;
    myDouble = new double[num];
    for (int c0 = 0; c0 < num; ++c0)
      myDouble[c0] = 2 + myByteBuffer.getLong() / (double) Long.MAX_VALUE;
  }

  void swap(byte[] myByte) {
    double seed = myByte.length % Math.PI;
    for (int c0 = 0; c0 < myByte.length; ++c0) {
      seed += myDouble[c0 % 4];
      if (Math.PI < seed)
        seed -= Math.PI;
      myByte[c0] ^= (byte) (Double.doubleToLongBits(Math.sin(seed)) >> (c0 % 17));
    }
  }

  byte[] encrypt(byte[] myInfl) {
    Deflater myDeflater = new Deflater(9);
    myDeflater.setInput(myInfl);
    myDeflater.finish();
    byte[] myDefl = new byte[myInfl.length + 128]; // header
    int size = myDeflater.deflate(myDefl);
    ByteBuffer myByteBuffer = ByteBuffer.wrap(new byte[size + 4]);
    myByteBuffer.put(myDefl, 0, size);
    myByteBuffer.putInt(myInfl.length);
    byte[] myTail = myMessageDigest.digest(myByteBuffer.array());
    myByteBuffer = ByteBuffer.wrap(new byte[size + 4 + myTail.length]);
    myByteBuffer.put(myDefl, 0, size);
    myByteBuffer.putInt(myInfl.length);
    myByteBuffer.put(myTail);
    byte[] myByte = myByteBuffer.array();
    swap(myByte);
    return myByte;
  }

  byte[] decrypt(byte[] myByte) throws Exception {
    swap(myByte);
    byte[] myComp = new byte[myByte.length - 32];
    ByteBuffer.wrap(myByte).get(myComp);
    byte[] myTail = myMessageDigest.digest(myComp);
    boolean myBoolean = true;
    for (int c0 = 0; c0 < 32; ++c0)
      myBoolean &= myByte[myComp.length + c0] == myTail[c0];
    if (!myBoolean)
      return null;
    ByteBuffer myByteBuffer = ByteBuffer.wrap(myComp);
    int size = myByteBuffer.getInt(myComp.length - 4);
    Inflater myInflater = new Inflater();
    myInflater.setInput(myComp, 0, myComp.length - 4);
    byte[] myHead = new byte[size];
    myInflater.inflate(myHead);
    myInflater.end();
    return myHead;
  }
}
