// code by jph
package sys.lic;

import java.io.InputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.List;

public class InternetTime {
  private static final List<String> hosts = Arrays.asList(new String[] { //
      "nist1.aol-va.symmetricom.com", //
      // "64.236.96.53", //
      "nist1-atl.ustiming.org", //
      // "64.250.177.145", //
      "nist1-chi.ustiming.org", //
      // "208.66.175.36", //
      "nist.expertsmi.com", //
      // "50.77.217.185", //
      "nisttime.carsoncity.k12.mi.us", //
      // "66.219.116.140", //
      "nist1-lnk.binary.net", //
      // "216.229.0.179", //
      "time-a.timefreq.bldrdoc.gov", //
      // "132.163.4.101", //
      "time-b.timefreq.bldrdoc.gov", //
      // "132.163.4.102", //
      "time-c.timefreq.bldrdoc.gov", //
      // "132.163.4.103", //
      "time.nist.gov", //
      // "131.107.13.100", //
      "utcnist.colorado.edu", //
      // "128.138.140.44", //
      // "utcnist2.colorado.edu", //
      "128.138.141.172", //
      // "ntp-nist.ldsbc.edu", //
      "198.60.73.8", //
      // "nist-time-server.eoni.com", //
      "216.228.192.69", //
      // "nist1.aol-ca.symmetricom.com", //
      "207.200.81.113", //
      // "nist1.symmetricom.com", //
      "69.25.96.13" //
  });

  public static int byte2int(byte myByte) {
    int myInt = myByte;
    return myInt < 0 ? myInt + 256 : myInt;
  }

  public static InetAddress firstInetAddress = null;

  public static String staticInetAddressString() {
    if (firstInetAddress == null)
      return "no-internet";
    byte[] ip = firstInetAddress.getAddress();
    StringBuilder myStringBuffer = new StringBuilder();
    for (int c0 = 0; c0 < ip.length; ++c0)
      myStringBuffer.append(InternetTime.byte2int(ip[c0]) + ".");
    // System.out.println("appended "+myStringBuffer.toString());
    return myStringBuffer.toString();
  }

  // ---
  public static Calendar getCalendar() {
    Collections.shuffle(hosts);
    for (String myString : hosts)
      try {
        Socket mySocket = new Socket(InetAddress.getByName(myString), 13);
        InputStream myInputStream = mySocket.getInputStream();
        int count = 0;
        while (myInputStream.available() < 51 && ++count < 50)
          Thread.sleep(50); // 20 too slow
        int myInt = myInputStream.available();
        if (myInt == 51) {
          byte[] myByte = new byte[myInt];
          myInputStream.read(myByte);
          String myTime = new String(myByte);
          Calendar myCalendar = Calendar.getInstance();
          myCalendar.set(Calendar.YEAR, 2000 + Integer.parseInt(myTime.substring(7, 9)));
          myCalendar.set(Calendar.MONTH, Integer.parseInt(myTime.substring(10, 12)) - 1); // JANUARY is 0, etc.
          myCalendar.set(Calendar.DAY_OF_MONTH, Integer.parseInt(myTime.substring(13, 15)));
          myCalendar.set(Calendar.HOUR_OF_DAY, Integer.parseInt(myTime.substring(16, 18)));
          myCalendar.set(Calendar.MINUTE, Integer.parseInt(myTime.substring(19, 21)));
          myCalendar.set(Calendar.SECOND, Integer.parseInt(myTime.substring(22, 24)));
          myCalendar.set(Calendar.MILLISECOND, 0);
          if (firstInetAddress == null) {
            firstInetAddress = mySocket.getLocalAddress();
            // System.out.println("assigned = " + firstInetAddress);
          }
          myInputStream.close(); // TODO line not tested
          mySocket.close();
          return myCalendar;
        }
        mySocket.close();
        // System.out.println("InternetTime host " + myString + " returned " + myInt + " byte(s) in " + count + " attempt(s), fail!");
      } catch (Exception myException) {
        // myException.printStackTrace();
      }
    return null;
  }
}
