// code by jph
package sys.mat;

public class Fractions {
  /** code from http://www.ics.uci.edu/~eppstein/numth/frap.c
   * 
   * @param val for instance Math.PI, or 2/3.
   * @param max denominator
   * @return */
  public static Fraction approximate(final double val, final int max) {
    long m00 = 1;
    long m01 = 0;
    long m10 = 0;
    long m11 = 1;
    double cpy = val;
    long ain;
    while (m10 * (ain = (long) cpy) + m11 <= max) { // loop finding terms until denom gets too big
      long tmp;
      tmp = m00 * ain + m01;
      m01 = m00;
      m00 = tmp;
      tmp = m10 * ain + m11;
      m11 = m10;
      m10 = tmp;
      if (cpy == ain)
        break; // AF: division by zero
      cpy = 1 / (cpy - ain);
      if (cpy > Integer.MAX_VALUE)
        break; // AF: representation failure
    }
    // now remaining x is between 0 and 1/ai
    // approx as either 0 or 1/m where m is max that will fit in maxden
    // first try zero
    Fraction mySol0 = new Fraction((int) m00, (int) m10);
    double err0 = Math.abs(val - mySol0.doubleValue());
    // now try other possibility
    ain = (max - m11) / m10;
    Fraction mySol1 = new Fraction((int) (m00 * ain + m01), (int) (m10 * ain + m11));
    double err1 = Math.abs(val - mySol1.doubleValue());
    return err0 < err1 ? mySol0 : mySol1;
  }

  public static Fraction add(Fraction a, Fraction b) {
    return a.add(b);
  }

  public static Fraction mul(Fraction a, Fraction b) {
    return a.mul(b);
  }
}
