// code by jph
package sys.mat;

public class FriendlyFormat {
  /** by aioobe on stackoverflow
   * 
   * @param bytes
   * @param si
   * @return */
  public static String byteSize(long bytes, boolean si) {
    int unit = si ? 1000 : 1024;
    if (bytes < unit)
      return bytes + " B";
    int exp = (int) (Math.log(bytes) / Math.log(unit));
    String pre = (si ? "kMGTPE" : "KMGTPE").charAt(exp - 1) + (si ? "" : "i");
    return String.format("%.1f %sB", bytes / Math.pow(unit, exp), pre);
  }

  public static String chop(int decimals, double value) {
    String myString = String.format("%1." + decimals + "f", value);
    int index = myString.indexOf('.');
    if (0 < index) {
      char[] myChar = myString.toCharArray();
      int count;
      for (count = myString.length() - 1; index < count; --count) {
        if (myChar[count] != '0')
          break;
      }
      if (count == index)
        --count;
      myString = myString.substring(0, count + 1);
    }
    return myString;
  }

  /** returns part of a byte array as a hex string. for instance message[0]=0xfe and message[1]=0x23 then hexString(message,0,2) = "0xfe23"
   * 
   * @param message byte array
   * @param offset from where to read bytes
   * @param length number of bytes to concatenate to the string
   * @param pattern for instance "%02x"
   * @return hex string, for instance "0xfe23" */
  public static String hexString(byte[] message, int offset, int length, String pattern) {
    StringBuffer myStringBuffer = new StringBuffer();
    for (int c1 = 0; c1 < length; ++c1)
      myStringBuffer.append(String.format(pattern, message[offset + c1]));
    return myStringBuffer.toString();
  }

  public static void main(String[] args) {
    System.out.println(chop(3, 3.0));
    System.out.println(chop(3, 3.1));
    System.out.println(chop(3, Math.PI));
  }
}
