// code by jph
package sys.mat;

import java.util.Comparator;
import java.util.Map;

public class MapComparator {
  private MapComparator() {
  }

  public static <Type> Comparator<Type> integer(final Map<Type, Integer> myMap) {
    return new Comparator<Type>() {
      @Override
      public int compare(Type myType1, Type myType2) {
        return Integer.compare(myMap.get(myType1), myMap.get(myType2));
      }
    };
  }

  public static <Type> Comparator<Type> integerReverse(final Map<Type, Integer> myMap) {
    return new Comparator<Type>() {
      @Override
      public int compare(Type myType1, Type myType2) {
        if (!myMap.containsKey(myType1))
          throw new RuntimeException("!contained " + myType1);
        if (!myMap.containsKey(myType2))
          throw new RuntimeException("!contained " + myType2);
        return Integer.compare(myMap.get(myType2), myMap.get(myType1));
      }
    };
  }
}
