// code by jph
package sys.mat;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.NavigableMap;

public class MapOperations {
  public static <Type> void translate(Map<Integer, Type> mySrc, int offset, Map<Integer, Type> myDst) {
    for (Entry<Integer, Type> myEntry : mySrc.entrySet())
      myDst.put(myEntry.getKey() + offset, myEntry.getValue());
  }

  public static <Type> void translate(Map<Integer, Type> myMap, int offset) {
    Map<Integer, Type> myBuffer = new HashMap<>(myMap);
    myMap.clear();
    translate(myBuffer, offset, myMap);
  }

  public static <Type> void scaleMap(NavigableMap<Integer, Type> myNavigableMap, Fraction myFraction) {
    Map<Integer, Type> myMap = new HashMap<>();
    for (Entry<Integer, Type> myEntry : myNavigableMap.entrySet())
      myMap.put(myFraction.times(myEntry.getKey()).toInteger(), myEntry.getValue());
    myNavigableMap.clear();
    myNavigableMap.putAll(myMap);
  }

  public static <Type> void scaleMapSafe(NavigableMap<Integer, Type> myNavigableMap, Fraction myFraction) {
    Map<Integer, Type> myMap = new HashMap<>();
    for (Entry<Integer, Type> myEntry : myNavigableMap.entrySet())
      myMap.put(myFraction.times(myEntry.getKey()).floor(), myEntry.getValue());
    myNavigableMap.clear();
    myNavigableMap.putAll(myMap);
  }
}
