// code by jph
package sys.mat;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import tpf.eng.Note;

/** iterator over list of items (by reference, i.e. items are not cloned) */
public class OuterProduct<Type> implements Iterator<List<Type>>, Iterable<List<Type>> {
  final List<List<Type>> myList;
  final OuterProductInteger myOuterProductInteger;

  public OuterProduct(List<List<Type>> myList) {
    this.myList = myList;
    int[] myInt = new int[myList.size()];
    int count = 0;
    for (List<Type> myBucket : myList) {
      myInt[count] = myBucket.size();
      ++count;
    }
    myOuterProductInteger = new OuterProductInteger(myInt);
  }

  @Override
  public boolean hasNext() {
    return myOuterProductInteger.hasNext();
  }

  @Override
  public List<Type> next() {
    myOuterProductInteger.next(); // first evil
    List<Type> myList = new ArrayList<>();
    int count = 0;
    for (List<Type> myBucket : this.myList) {
      myList.add(myBucket.get(myOuterProductInteger.myInteger[count])); // second evil
      ++count;
    }
    return myList;
  }

  @Override
  public void remove() {
  }

  @Override
  public Iterator<List<Type>> iterator() {
    return this;
  }

  public static void main(String[] args) {
    List<List<Note>> myList = new ArrayList<>();
    myList.add(Arrays.asList(new Note[] { Note.create("c0 4"), Note.create("d0 1") }));
    myList.add(Arrays.asList(new Note[] { Note.create("a0 2"), Note.create("b0 2"), Note.create("f0 2") }));
    for (List<Note> myL : new OuterProduct<Note>(myList))
      System.out.println(myL);
  }
}
