// code by jph
package sys.mat;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

/** serves as the algorithm for OuterProduct */
class OuterProductInteger implements Iterator<List<Integer>>, Iterable<List<Integer>> {
  final Integer[] myInteger;
  final int[] myInt;
  int count = 0;
  final int total;

  OuterProductInteger(int[] myInt) {
    int total = 1;
    myInteger = new Integer[myInt.length];
    for (int c0 = 0; c0 < myInt.length; ++c0) {
      myInteger[c0] = 0;
      total *= myInt[c0];
    }
    this.myInt = myInt;
    this.total = total;
  }

  @Override
  public boolean hasNext() {
    return count < total;
  }

  @Override
  public List<Integer> next() {
    if (0 < count)
      for (int c0 = myInt.length - 1; 0 <= c0; --c0) {
        ++myInteger[c0];
        myInteger[c0] %= myInt[c0];
        if (myInteger[c0] != 0)
          break;
      }
    ++count;
    return Arrays.asList(myInteger);
  }

  @Override
  public void remove() {
  }

  @Override
  public Iterator<List<Integer>> iterator() {
    return this;
  }

  public static void main(String[] args) {
    OuterProductInteger myOuterProduct = new OuterProductInteger(new int[] { 4, 1, 2, 3 });
    for (List<Integer> myList : myOuterProduct) {
      System.out.println(myList);
    }
  }
}
