// code by jph
package sys.mat.num;

import java.util.Map.Entry;
import java.util.NavigableMap;
import java.util.TreeMap;

public class LinearInterpolation implements Interpolation {
  public NavigableMap<Double, Double> myNavigableMap = new TreeMap<>();
  public Double loAlt = null;
  public Double hiAlt = null;

  public void put(double key, double value) {
    myNavigableMap.put(key, value);
  }

  @Override
  public double get(double key) throws NullPointerException {
    if (myNavigableMap.containsKey(key))
      return myNavigableMap.get(key);
    Entry<Double, Double> lo = myNavigableMap.lowerEntry(key);
    if (lo == null)
      return loAlt;
    Entry<Double, Double> hi = myNavigableMap.higherEntry(key);
    if (hi == null)
      return hiAlt;
    double lam = (key - lo.getKey()) / (hi.getKey() - lo.getKey());
    return hi.getValue() * lam + lo.getValue() * (1 - lam);
  }

  public static void main(String[] args) {
    LinearInterpolation myLinearInterpolation = new LinearInterpolation();
    myLinearInterpolation.put(10., 100.);
    myLinearInterpolation.put(11., 9.);
    System.out.println(myLinearInterpolation.get(11));
  }
}
