// code by jph
package sys.ref;

import java.io.File;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.SortedMap;
import java.util.TreeMap;

public class ClassHtml extends ClassVisitor {
  public int totalBytes = 0;
  public final Map<Class<?>, File> myMap = new HashMap<>();
  public final List<Class<?>> myList;

  public ClassHtml(String myString) {
    visitRecursively(new File(myString));
    // System.out.println(myMap.size());
    myList = new ArrayList<>(myMap.keySet());
    Collections.sort(myList, new Comparator<Class<?>>() {
      @Override
      public int compare(Class<?> myClass1, Class<?> myClass2) {
        return Long.compare(myMap.get(myClass2).lastModified(), myMap.get(myClass1).lastModified());
      }
    });
    DateFormat myDateFormat = new SimpleDateFormat("yyyy.MM.dd");
    SortedMap<String, Integer> mySortedMap = new TreeMap<>();
    for (Class<?> myClass : myList) {
      long myLong = myMap.get(myClass).lastModified();
      String myDate = myDateFormat.format(new Date(myLong));
      int length = (int) myMap.get(myClass).length();
      totalBytes += length;
      // System.out.println(myDate + '\t' + "" + length + '\t' + myClass.toString());
      mySortedMap.put(myDate, mySortedMap.containsKey(myDate) ? mySortedMap.get(myDate) + 1 : 1);
    }
    // System.out.println("---");
    List<String> myStats = new ArrayList<>();
    for (Entry<String, Integer> myEntry : mySortedMap.entrySet())
      myStats.add(myEntry.getKey() + "\t" + myEntry.getValue());
    Collections.reverse(myStats);
    // for (String myToken : myStats)
    // System.out.println(myToken);
  }

  public List<Class<?>> bySize() {
    List<Class<?>> myList = new ArrayList<>(myMap.keySet());
    Collections.sort(myList, new Comparator<Class<?>>() {
      @Override
      public int compare(Class<?> myClass1, Class<?> myClass2) {
        return Long.compare(myMap.get(myClass2).length(), myMap.get(myClass1).length());
        // return Long.compare(myMap.get(myClass2).lastModified(), myMap.get(myClass1).lastModified());
      }
    });
    return myList;
  }

  @Override
  public void visitFile(File myFile, Class<?> myClass) {
    // System.out.println(myClass.getSimpleName());
    myMap.put(myClass, myFile);
  }

  public static void main(String[] args) {
    ClassHtml myClassHtml = new ClassHtml("src/tpf");
    System.out.println("total bytes " + myClassHtml.totalBytes);
  }
}
