// code by jph
package sys.ref;

import java.io.File;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;

public class PackageTree extends ClassVisitor {
  public static final String tabs = "\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t";
  // ---
  public Map<CodePoint, Set<CodePoint>> myMap = new TreeMap<>();
  Set<String> set = new HashSet<>();

  public PackageTree(String myString) throws Exception {
    visitRecursively(new File(myString));
    Class<?> myClass = Class.forName("java.lang.Object"); // FingeringRow
    recur(0, new ClassInfo(myClass));
  }

  public void recur(int level, CodePoint myCodePoint) {
    for (CodePoint mySub : myMap.get(myCodePoint)) {
      String myString = mySub.toString();
      if (set.add(myString))
        System.out.println(tabs.substring(0, level) + myString);
      recur(level + 1, mySub);
    }
  }
  
//  Map<Class<?>, Integer>

  @Override
  public void visitFile(File myFile, Class<?> myClass) {
//    System.out.println(myFile+" "+myClass.getSimpleName());
    while (myClass != null) {
      Class<?> mySuper = myClass.getSuperclass();
      ClassInfo myClassInfo = new ClassInfo(myClass);
      if (!myMap.containsKey(myClassInfo))
        myMap.put(myClassInfo, new TreeSet<>());
      if (mySuper != null) {
        ClassInfo myClassInfoSuper = new ClassInfo(mySuper);
        if (!myMap.containsKey(myClassInfoSuper))
          myMap.put(myClassInfoSuper, new TreeSet<>());
        // ---
        if (mySuper.getName().equals("java.lang.Object")) {
          PackageInfo myPackageInfo = new PackageInfo(myFile.getParent().substring(4).replace('\\', '.'));
          myMap.get(myClassInfoSuper).add(myPackageInfo);
          if (!myMap.containsKey(myPackageInfo))
            myMap.put(myPackageInfo, new TreeSet<>());
          myMap.get(myPackageInfo).add(myClassInfo);
        } else {
          myMap.get(myClassInfoSuper).add(myClassInfo);
        }
      }
      myClass = mySuper;
    }
  }

  public static void main(String[] args) throws Exception {
    new PackageTree("src/tpf");
    System.exit(0);
  }
}
