// code by jph
package sys.wav;

import java.util.ArrayList;
import java.util.Collection;

import javax.sound.sampled.AudioFormat;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.DataLine;
import javax.sound.sampled.Line;
import javax.sound.sampled.Mixer;

public abstract class Wave {
  public Collection<MixerDataFormat> getLines(AudioFormat myAudioFormat) {
    Collection<MixerDataFormat> myCollection = new ArrayList<>();
    for (Mixer.Info myMixerInfo : AudioSystem.getMixerInfo()) {
      Mixer myMixer = AudioSystem.getMixer(myMixerInfo);
      for (Line.Info myLineInfo : myMixer.getTargetLineInfo()) {
        DataLine.Info myDataLineInfo = new DataLine.Info(myLineInfo.getLineClass(), myAudioFormat);
        if (acceptDataLine(myDataLineInfo, myAudioFormat))
          myCollection.add(new MixerDataFormat(myMixerInfo, myDataLineInfo, myAudioFormat));
      }
    }
    return myCollection;
  }

  protected abstract boolean acceptDataLine(DataLine.Info myDataLineInfo, AudioFormat myAudioFormat);

  public MixerDataFormat getMixerDataFormat(Collection<MixerDataFormat> myCollection, String myString) {
    for (MixerDataFormat myMixerDataFormat : myCollection)
      if (myMixerDataFormat.toString().equals(myString))
        return myMixerDataFormat;
    return null;
  }
}
